<template>
  <popup ref="popup" @close="$emit('close')">
    <div class="qrcode-panel">
      <div class="content">
        <div class="close-button">
          <close-button @click="() => $refs.popup && $refs.popup.close()" />
        </div>
        <panel-restaurant :restaurant="restaurant" />
        <div class="panel-body">
          <qr-code class="qrcode" :text="order.id" :size="265" />
          <div class="number-label">{{ $t("preorderQrCode.number") }}</div>
          <div class="number-value">{{ last6CharOrderId }}</div>
          <div class="desc">{{ $t("preorderQrCode.desc") }}</div>
        </div>
      </div>
    </div>
  </popup>
</template>

<script>
import Popup from "../Popup";
import QRCode from "vue-qrcode-component";
import PanelRestaurant from "./PanelRestaurant";
import CloseButton from "@/components/CloseButton";
import { last6Char } from "@/utils";

export default {
  components: {
    Popup,
    "qr-code": QRCode,
    PanelRestaurant,
    CloseButton
  },

  props: {
    restaurant: {
      type: Object
    },
    order: {
      type: Object
    }
  },
  computed: {
    last6CharOrderId() {
      return last6Char(this.order.id);
    }
  }
};
</script>

<style lang="scss" scoped>
.qrcode-panel {
  position: relative;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  margin: 0 auto;
  user-select: none;
  text-align: center;
  box-sizing: border-box;

  @include media-breakpoint-up(md) {
    &::after {
      content: "";
      display: inline-block;
      height: 100%;
      width: 0;
      vertical-align: middle;
    }
  }
}

.content {
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background: $color-white;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);
  box-sizing: border-box;
  overflow-y: scroll;
  text-align: left;
  padding: 20px;

  @include media-breakpoint-up(md) {
    display: inline-block;
    width: 540px;
    position: relative;
    vertical-align: middle;
    max-height: 90vh;
    padding: 30px;
  }
}

.close-button {
  position: absolute;
  z-index: 1;
  top: 10px;
  right: 10px;
  width: 32px;
  height: 32px;
  vertical-align: middle;

  @include media-breakpoint-up(md) {
    top: 20px;
    right: 20px;
  }
}

.qrcode {
  width: 295px;
  margin: 0 auto 10px;
  padding: 15px;
  box-sizing: border-box;
}

.number-label,
.number-value {
  text-align: center;
}

.number-label {
  color: $color-secondary-black;
  font-size: 13px;
  font-weight: normal;
  line-height: 20px;
  margin-bottom: 10px;
}

.number-value {
  font-size: 40px;
  font-weight: 600;
  line-height: 42px;
  margin-bottom: 30px;
}

.desc {
  color: $color-primary-grey;
  padding: 0 15px;
}
</style>
